;*****************************************************************************
;
;                            D   D   L   S   T
;
;              Lisp Programmsammlung mit Dialogboxinterface
;                zur Aufzeichnung von Layereinstellungen
;
;                         V  E  R  S  I  O  N    1.07
;
;
; (C) Robert Schweisser 04/11/1997                         Tel. 069 / 87 17 57
;
;*****************************************************************************

(defun C:DDL

 (/ F:ALTSET F:DBOX F:ERR F:HLST F:HOLBEZ F:L2D F:SETALT F:SLST F:ALTERR

    ALTC ALTE BRK OPTION
 )

;----------------------- ALLGEMEINE HILFSFUNKTIONEN --------------------------
;
; H:GETV bentigt einen Integer-Dxf-Code und eine Elementdatenliste.
; ------------------------------------------------------------------
; Gibt das 2. Element der Assoziationliste ,die Elementdaten ,zurck.
; -------------------------------------------------------------------

(defun H:GETV(CODE ELIST)(cdr (assoc CODE ELIST)))

;---- UNTERPROGRAMME PROGRAMMUMGEBUNG EINRICHTEN UND RCKSETZEN --------------

 (defun F:ALTSET() 
  (setq ALTC (getvar "CMDECHO"))
  (setq ALTE (getvar "EXPERT"))
  (setvar "CMDECHO" 0)
  (setq F:ALTERR  *ERROR* 
        *ERROR*   F:ERR
  )
  (princ)
 ) 

 (defun F:SETALT() 
  (command "._UNDO" "_E")
  (setvar "CMDECHO" ALTC)
  (setvar "EXPERT" ALTE)
  (setq *ERROR* F:ALTERR)
  (princ)
 ) 

 (defun F:ERR(MSG) 
  (if (OR (= MSG "Function cancelled") (= MSG "Funktion abgebrochen")) 
   (princ "\n! Das Programm wurde abgebrochen !  ") 
   (princ (strcat "\nFolgender Fehler wurde gemeldet : " MSG))
  ) 
  (F:SETALT) 
  (princ)
 ) 

;------------------------- BEZEICHNUNGS-SEPARATION ---------------------------

 (defun F:HOLBEZ (ZEILE MUSTER / IDX MUSTLEN MUSTLST ZEILENG ZEILST
                   ZEILEL NZEIL NFLAG
                  ) 
  (setq      IDX 1 
         MUSTLEN (strlen MUSTER) 
         MUSTLST (list)
  )
  (while (<= IDX MUSTLEN) 
   (setq MUSTLST (cons (substr MUSTER IDX 1) MUSTLST) 
             IDX (1+ IDX)
   )
  )
  (setq      IDX 1
         ZEILENG (strlen ZEILE) 
             ZEILST (list) 
             NZEIL ""
             NFLAG T
  )
  (while (<= IDX ZEILENG) 
   (setq ZEILEL (substr ZEILE IDX 1))
   (if (member ZEILEL MUSTLST) 
    (if (null NFLAG) 
     (setq  NFLAG T 
           ZEILST (cons NZEIL ZEILST) 
            NZEIL ""
     )
    )
    (setq NFLAG nil 
          NZEIL (strcat NZEIL ZEILEL)
    )
   )
   (setq IDX (1+ IDX))
  ) 
  (if (null NFLAG) 
   (setq ZEILST (cons NZEIL ZEILST))
  )
  (if ZEILST 
   (reverse ZEILST) 
   nil
  )
 )

;----------------------- LAYERSTAND IN DATEI SCHREIBEN -----------------------

 (defun F:L2D

  (/ F:DEFAULT F:GETBEZ F:DATUM
     NAM DAT NBEZ LDAT LNAM LCOL LLOCK LSTAT LTYPE LFREZ LSATZ FILE BEZA TXT
  )

  (defun F:DEFAULT()(set_tile "BEZ" BEZA))

  (defun F:GETBEZ()(setq NBEZ (get_tile "BEZ")))

  (defun F:DATUM (/ DAT)
   (setq DAT (rtos (getvar "CDATE") 2 10))
   (setq TXT (strcat (substr DAT 7 2)  ;Tag
              "." (substr DAT 5 2)     ;Monat
              "." (substr DAT 3 2)     ;Jahr
              " "  (substr DAT 10 2)   ;Stunden
              ":" (substr DAT 12 2)    ;Minuten
              " Uhr"
             )
   )
  )

  (F:DATUM)
  (setq NAM (getvar "DWGNAME"))
  (if (null BEZA)
   (progn
    (setq BEZA (strcat NAM " vom " TXT))
   )
   (progn
    (if (> (strlen BEZA) (+ (strlen TXT) 7))
     (setq BEZA (substr BEZA 1 (- (strlen BEZA) (+ (strlen TXT) 4))))
    )
    (setq BEZA (strcat BEZA "vom " TXT))
   )
  )
  (setq NBEZ nil)
  (setq Dat (load_dialog "DDLST1_7.DCL"))
  (if (not (new_dialog "LSTAND" Dat)) (exit))
  (set_tile "BEZ" BEZA)
  (action_tile "VOR" "(F:DEFAULT)")
  (action_tile "accept" "(F:GETBEZ) (done_dialog)")
  (action_tile "cancel" "(done_dialog)")
  (start_dialog)
  (unload_dialog Dat)
  (if NBEZ 
   (progn
    (setq  FILE (open DATNAM "w")    LDAT nil)
    (write-line (strcat (getvar "CLAYER") "*" NBEZ) FILE)
    (while (setq LDAT (tblnext "LAYER" (not LDAT)))
     (setq LNAM (H:GETV 2 LDAT)
           LCOL (H:GETV 62 LDAT)
           LSTAT (if (minusp LCOL) "_OFF" "_ON")
           LCOL (itoa LCOL)
           LTYPE (H:GETV 6 LDAT)
           LFREZ (if (zerop (logand (H:GETV 70 LDAT) 1)) "_THAW" "_FREEZE")
           LLOCK (if (= (logand (H:GETV 70 LDAT) 4) 4) "_LOCK" "_UNLOCK")
           LSATZ (strcat LNAM " " LFREZ " " LLOCK " " LSTAT " " LCOL " " LTYPE)
     )
     (write-line LSATZ FILE)
    )
    (close FILE) 
    (princ "\nDie momentanen Layer-Einstellungen wurden in :\n > ")
    (princ DATNAM)
    (princ " <  gesichert !")
   )
   (progn
    (princ "\n ! Die Datei  > ")
    (princ DATNAM)
    (princ " <  wurde nicht verndert !")
    (setq ANTWFLAG nil)
   )
  )
 )
;------------------------- LAYERSTAND DIALOGBOX ------------------------------

 (defun F:DBOX

  (/ F:SP F:LA F:DI F:END F:ABR

     DAT
  )


; OPTION SPEICHERN

  (defun F:SP()(setq OPTION "Speichern")(done_dialog))


; OPTION LADEN

  (defun F:LA()
   (if (= (get_tile "AN") "1")
    (setq ANPASS T OPTION "Laden")
    (setq ANPASS nil OPTION "Laden")
   )
   (done_dialog)
  )


; OPTION DIALOG

  (defun F:DI()(setq OPTION "Dialog")(done_dialog))


; OPTION FERTIG

  (defun F:END()(setq OPTION nil)(done_dialog))


; OPTION ABBRUCH

  (defun F:ABR()(setq OPTION nil BRK T)(done_dialog))



  (setq Dat (load_dialog "DDLST1_7.DCL"))
  (if (not (new_dialog "OPTION" Dat)) (exit))
  (action_tile "SP" "(F:SP)")
  (action_tile "LA" "(F:LA)")
  (action_tile "DI" "(F:DI)")
  (action_tile "AUS" "(F:END)")
  (action_tile "BREAK" "(F:ABR)")
  (start_dialog)
  (unload_dialog Dat)
 )

;------------------------- LAYERSTAND SPEICHERN ------------------------------

 (defun F:SLST(/ MSG DNAM BEZA SPEZ DATNAM ANTWFLAG FILE LINE1)

  (setq ANTWFLAG nil DWGNAM (getvar "DWGNAME"))
  (setq DNAM (substr DWGNAM 1 (- (strlen DWGNAM) 4)))
   
  (setq DATNAM (getfiled "LAYERSTNDE SICHERN" DNAM "LSL" 1))
  (if (/= DATNAM nil)
   (progn
    (if (null (setq FILE (open DATNAM "r")))
     (progn      ;Die gewhlte Datei existiert nicht!
      (setq MSG (strcat "Die Datei " DATNAM " wird NEU erzeugt!"))
      (alert MSG)
      (setq ANTWFLAG T)
     )
     (if (null (setq LINE1 (read-line FILE)))
      (progn
       (close FILE)     ;Die gewhlte Datei enthlt nichts!
       (setq ANTWFLAG T BEZA "Undefiniert")
      )
      (if (null (setq SPEZ (cadr (F:HOLBEZ LINE1 "*"))))
       (progn
        (close FILE)
        (setq ANTWFLAG T BEZA "Undefiniert")
       )
       (progn
        (close FILE)
        (setq ANTWFLAG T BEZA SPEZ)
       )
      )
     )
    )
   )
  )

; Layerstand in Datei schreiben
  (if (= ANTWFLAG T)
   (F:L2D)
   (progn
    (princ "\n ! Die Datei  > ")
    (princ DATNAM)
    (princ " <  wurde nicht verndert !")
    (setq ANTWFLAG nil)
   )
  )
  (princ)
 )

;------------------------- LAYERSTAND LADEN ----------------------------------

 (defun F:HLST

  (/ F:REME F:LMAKE F:LSET

     ALL DAT SPEZ DATNAM MSG MSGB AKTU LNAM ANTWFLAG FILE NLST LINE1 LSTS
     RS_NLIST RS_XLIST MAKEFLAG SAVEFLAG LINE ALIST
  )


;------------------------- ELEMENT AUS LISTE ENTFERNEN -----------------------

 (defun F:REME (OLIS RELE)

   (if (member RELE OLIS)

                              ;Wenn RELE in OLIS vorhanden ist
      (append
                              ;Dann, verbinde

        (reverse (cdr (member RELE (reverse OLIS))))

                              ;Liste OLIS umkehren, mit member RELE und  den Rest der Liste
                              ;herausfiltern, mit cdr RELE entfernen und nun die ganze Liste
                              ;umkehren
                              ;1. Teil der Liste

        (cdr (member RELE OLIS))

                              ;Mit member RELE und  den Rest der Liste herausfiltern, mit cdr
                              ;RELE entfernen
                              ;2. Teil der Liste
      )
      OLIS
                              ;Sonst OLIS unverndert zurckgeben
   )
)

;------------------------- LAYER NEU ERZEUGEN -------------------------------

 (defun F:LMAKE(LINE / LNAM DAT MSGA ANT)
  (setq LNAM (car LINE))
  (setq MSGA (strcat "Der Layer " LNAM))
  (setq Dat (load_dialog "DDLST1_7.DCL"))
  (if (not (new_dialog "YESNO" Dat)) (exit))
  (set_tile "YESNO" "Sicherheitsanfrage") 
  (set_tile "MSG1" MSGA)
  (set_tile "MSG2"  "ist in dieser Zeichnung nicht vorhanden!") 
  (set_tile "MSG3" "Soll dieser Layer jetzt erzeugt werden?") 
  (action_tile "NO" "(progn (setq ANT nil) (done_dialog))") 
  (action_tile "YES" "(progn (setq ANT T) (done_dialog))") 
  (start_dialog) 
  (unload_dialog DAT)
  (if ANT 
   (progn
    (command "_.LAYER" "_NEW" LNAM)
    (command (nth 1 LINE) LNAM)
    (command (nth 2 LINE) LNAM)
    (command (nth 3 LINE) LNAM)
    (command
     "_COLOR" (nth 4 LINE) LNAM
     "_LTYPE" (nth 5 LINE) LNAM
     ""
    ) 
    (princ "\n !  Neuer Layer  >")
    (princ LNAM)
    (princ " <  wurde erstellt  !\n")
   )
   (princ "\n !  Kein neuer Layer erzeugt !")
  )
 )


;----------------------------- LAYER SETZEN ----------------------------------

 (defun F:LSET(LNAM)
  (command "_MAKE" LNAM "")
  (princ "\nDer Layer  > ")
  (princ LNAM)
  (princ " <  wurde gesetzt !")
 )

;------------------------ HAUPTPROGRAMM LAYERSTAND LADEN ---------------------

  (setq ANTWFLAG nil)
  (setq DATNAM (getfiled "LAYERSTAND LADEN" "" "LSL" 4))

  (if (/= DATNAM nil)
   (progn
    (if (null (setq FILE (open DATNAM "r")))
     (progn
      (close FILE)
      (setq MSG (strcat "Die gewhlte Datei " DATNAM " existiert nicht!"))
      (alert MSG)
     )
     (if (null (setq LINE1 (read-line FILE)))
      (progn
       (close FILE)
       (setq MSG (strcat "Die gewhlte Datei " DATNAM " enthlt nichts!"))
       (alert MSG)
      )
      (if (null (setq SPEZ (cadr (F:HOLBEZ LINE1 "*"))))
       (progn
        (close FILE)
        (setq MSG (strcat "Die gewhlte Datei " DATNAM " enthlt keine Beschreibung!"))
        (alert MSG)
       )
       (if ANPASS
        (progn
         (setq Dat (load_dialog "DDLST1_7.DCL"))
         (if (not (new_dialog "YESNO" Dat)) (exit))
         (set_tile "YESNO" "Sicherheitsanfrage") 
         (set_tile "MSG1" "Die gewhlte Datei hat die Kurz-Beschreibung:")
         (set_tile "MSG2" SPEZ) 
         (set_tile "MSG3" "Soll dieser Layerstand geladen werden?") 
         (action_tile "NO" "(progn (setq ANTWFLAG nil) (done_dialog))") 
         (action_tile "YES" "(progn (setq ANTWFLAG T) (done_dialog))") 
         (start_dialog) 
         (unload_dialog DAT)
        );progn
        (setq ANTWFLAG T)
       )
      )
     )
    )
   )
  )

  (if (= ANTWFLAG T) 
   (progn
    (setq ALL nil RS_NLIST nil RS_XLIST nil)
    (setvar "EXPERT" 4)
    (while                                          
     (setq LSTS (H:GETV 2 (tblnext "LAYER" (not LSTS))))
     (setq ALL (cons LSTS ALL))                    
    )                                                
    (setq FILE (open DATNAM "r"))
    (command "_.LAYER")
    (setq LINE1 (F:HOLBEZ (read-line FILE) "*") 
          AKTU (car LINE1) 
    )
    (terpri)
    (while (setq LINE (read-line FILE))
     (setq LINE (F:HOLBEZ LINE " ") 
           LNAM (car LINE) 
     )
     (princ ".")
     (princ) 

     (if (tblsearch "LAYER" LNAM)

; Layer vorhanden
      (progn

; Tauen/frieren
       (command (nth 1 LINE) LNAM)

; Sperren
       (command (nth 2 LINE) LNAM) 

; Ein/aus
       (command (nth 3 LINE) LNAM) 

; Farbe
       (command "_COLOR" (nth 4 LINE) LNAM) 

; Wenn kein Xref-Linientyp
       (if (wcmatch (nth 5 LINE) "~*|*")
        (command "_LTYPE" (nth 5 LINE) LNAM) 
       )
       (setq ALL (F:REME ALL LNAM))
      )

; Layer nicht vorhanden

      (progn
       (if (wcmatch LNAM "~*|*")

; Keine Xrefs neu anlegen!
        (progn
         (setq NLST (list (nth 0 LINE)(nth 1 LINE)(nth 2 LINE)(nth 3 LINE)(nth 4 LINE)(nth 5 LINE)))
         (setq RS_NLIST (cons NLST RS_NLIST))
        )
        (progn
         (setq NLST (list (nth 0 LINE)(nth 1 LINE)(nth 2 LINE)(nth 3 LINE)(nth 4 LINE)(nth 5 LINE)))
         (setq RS_XLIST (cons NLST RS_XLIST))
        )
       )
      )
     )
    )
    (command "")
    (close FILE)


    (if ANPASS
     (progn

      (if RS_NLIST 
       (progn
        (setq Dat (load_dialog "DDLST1_7.DCL"))
        (if (not (new_dialog "YESNO" Dat)) (exit))
        (set_tile "YESNO" "Sicherheitsanfrage") 
        (set_tile "MSG1" "Der Layerstand enthlt Layer, die noch")
        (set_tile "MSG2" "nicht in der Zeichnung vorhanden sind!") 
        (set_tile "MSG3" "Sollen zustzlich Layer erzeugt werden?") 
        (action_tile "NO" "(progn (setq MAKEFLAG nil) (done_dialog))") 
        (action_tile "YES" "(progn (setq MAKEFLAG T) (done_dialog))") 
        (start_dialog) 
        (unload_dialog DAT)
       )
      )

      (if (null (tblsearch "LAYER" AKTU))
       (progn
        (setq MSGB (strcat  "Der zu setzende Layer " AKTU))
        (setq Dat (load_dialog "DDLST1_7.DCL"))
        (if (not (new_dialog "YESNO" Dat)) (exit))
        (set_tile "YESNO" "Sicherheitsanfrage") 
        (set_tile "MSG1" MSGB)
        (set_tile "MSG2" "ist noch nicht in der Zeichnung vorhanden!") 
        (set_tile "MSG3" "Sollen dieser zustzlich Layer erzeugt werden?") 
        (action_tile "NO" "(progn (setq AKTUFLAG nil) (done_dialog))") 
        (action_tile "YES" "(progn (setq AKTUFLAG T) (done_dialog))") 
        (start_dialog) 
        (unload_dialog DAT)
        (if AKTUFLAG
         (if (setq ALIST (assoc 'AKTU RS_NLIST))
          (progn
           (F:LMAKE ALIST)
           (append  (reverse (cdr (member ALIST (reverse RS_NLIST))))(cdr (member ALIST RS_NLIST)))
          )
          (if (assoc 'AKTU RS_XLIST)
           (progn
            (princ "\nEin XREF-Layer kann nicht gesetzt werden!")
            (F:LSET "0")
           )
           (progn
            (princ "\nDer Layerstand enthlt keine Einstellungen fr den Layer ")
            (princ AKTU)
            (F:LSET "0")
           )
          )
         )
         (F:LSET AKTU)
        )
       )
       (F:LSET AKTU)
      )

      (if MAKEFLAG ;MODUL DIALOGUNTERSTTZTE LAYERERZEUGUNG ENTWICKELN
       (progn
        (while RS_NLIST
         (setq LINE (car RS_NLIST))
         (setq RS_NLIST (cdr RS_NLIST))
         (F:LMAKE LINE)
        )
       )
      )

      (if RS_XLIST ; MODUL XREF-ANPASSUNG ENTWICKELN
       (progn
;      (princ "\n\nRS_XLIST = ")(princ RS_XLIST)
        (alert "XREF-Layerstruktur entspricht nicht der Liste!")
       )
      )

      (if ALL 
       (progn
        (princ "\n\nNoch nicht bercksichtigte Layer: ")
        (foreach ITEM ALL (terpri)(princ ITEM))
        (setq Dat (load_dialog "DDLST1_7.DCL"))
        (if (not (new_dialog "YESNO" Dat)) (exit))
        (set_tile "YESNO" "Sicherheitsanfrage") 
        (set_tile "MSG1" "Die Zeichnung enthlt Layer, die noch nicht")
        (set_tile "MSG2" "im Layerstand bercksichtigt sind! Soll der") 
        (set_tile "MSG3" "Layerstand nach Kontrolle neu gespeichert werden?") 
        (action_tile "NO" "(progn (setq SAVEFLAG nil) (done_dialog))") 
        (action_tile "YES" "(progn (setq SAVEFLAG T) (done_dialog))") 
        (start_dialog) 
        (unload_dialog DAT)
       )
      )

      (if SAVEFLAG
       (progn
         (command "_.DDLMODES")
        (F:L2D)
       )
      )

     )
    )

    (setvar "EXPERT" ALTE)
   );End progn ANTWFLAG T
  );End if ANTWFLAG T
  (princ)
 )

;------------------------- HAUPTFUNKTION -------------------------------------

 (command "._UNDO" "_GROUP")                 ;Den Gruppenmodus starten
                                             ;damit kan nach dem Lispprogramm
 (F:ALTSET)                                  ;alles mit einem Z-Befehl
                                             ;zurckgesetzt werden.
;(setvar "CMDECHO" 1)
 (setq BRK nil)
 (F:DBOX)

 (while OPTION
  (cond
   ((= OPTION "Speichern")(F:SLST))
   ((= OPTION "Laden")(F:HLST))
   ((= OPTION "Dialog")(command "._DDLMODES"))
  )
  (F:DBOX)
 )
 (if BRK
  (progn
   (command "._UNDO" "_E")
   (command "._U")
  )
 )
 (F:SETALT)
 (princ)
)
(princ "\nProgramm DDLST 1.07 geladen!\nAufruf mit DDL")
(princ)
; Ende des Programms
